------------------------------------------------------------------
--                                                              --
--  File:   Create_NC_Indexes_Growing.SQL                       --
--          Microsoft TPC-E Benchmark Kit Ver. 1.5.1-1009       --
--         Copyright Microsoft  2007, 2008                      --
--                                                              --
------------------------------------------------------------------
USE tpce
GO

---
--- Set Connection Attributes
---
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET QUOTED_IDENTIFIER ON
SET NUMERIC_ROUNDABORT OFF
GO

-- *** TRADE ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_TRADE_NC1' )
    CREATE UNIQUE INDEX IX_TRADE_NC1 ON TRADE(T_CA_ID, T_DTS, T_ID)
        WITH (PAD_INDEX = ON, FILLFACTOR = 95, MAXDOP = 24, SORT_IN_TEMPDB = ON)
        ON cst_fg
GO

CHECKPOINT
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_TRADE_NC2' )
    CREATE UNIQUE INDEX IX_TRADE_NC2 ON TRADE(T_S_SYMB, T_DTS, T_ID)
        WITH (PAD_INDEX = ON, FILLFACTOR = 95, MAXDOP = 24, SORT_IN_TEMPDB = ON)
        ON cst_fg
GO

CHECKPOINT
GO


-- *** BROKER ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_BROKER_NC1' )
    CREATE UNIQUE INDEX IX_BROKER_NC1 ON BROKER(B_NAME, B_ID)
        WITH (FILLFACTOR = 100, MAXDOP = 24)
        ON else_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_BROKER_NC2' )
    CREATE UNIQUE INDEX IX_BROKER_NC2 ON BROKER(B_ID, B_NAME)
        WITH (FILLFACTOR = 100, MAXDOP = 24)
        ON else_fg
GO

-- *** HOLDING ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_HOLDING_NC1' )
    CREATE UNIQUE INDEX IX_HOLDING_NC1 ON HOLDING(H_CA_ID, H_S_SYMB, H_DTS, H_T_ID)
        WITH (PAD_INDEX = ON, FILLFACTOR = 95, MAXDOP = 24, SORT_IN_TEMPDB = ON)
        ON else_fg
GO

CHECKPOINT
GO

-- *** HOLDING_HISTORY ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_HOLDING_HISTORY_NC1' )
    CREATE UNIQUE INDEX IX_HOLDING_HISTORY_NC1 ON HOLDING_HISTORY(HH_T_ID, HH_H_T_ID)
        WITH (PAD_INDEX = ON, FILLFACTOR = 100, MAXDOP = 24, SORT_IN_TEMPDB = ON)
        ON else_fg
GO

CHECKPOINT
GO

-- *** TRADE_REQUEST ***
IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_TRADE_REQUEST_NC1' )
    CREATE UNIQUE INDEX IX_TRADE_REQUEST_NC1 ON TRADE_REQUEST(TR_B_ID, TR_S_SYMB, TR_T_ID)
        WITH (FILLFACTOR = 100, MAXDOP = 24)
        ON else_fg
GO

IF NOT EXISTS ( SELECT name FROM sysindexes WHERE name = 'IX_TRADE_REQUEST_NC2' )
    CREATE UNIQUE INDEX IX_TRADE_REQUEST_NC2 ON TRADE_REQUEST(TR_S_SYMB, TR_T_ID, TR_TT_ID, TR_BID_PRICE, TR_QTY)
        WITH (FILLFACTOR = 100, MAXDOP = 24)
        ON else_fg
GO
